unit Schwerkraft;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Buttons, Spin;

type
  TF_Universum = class(TForm)
    Statuszeile: TStatusBar;
    Panel1: TPanel;
    b_neueschiffe: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    b_phi0: TEdit;
    b_v0: TEdit;
    L_Spielername: TLabel;
    l_Spielersymbol: TShape;
    tim_auswertung: TTimer;
    SpinButton1: TSpinButton;
    SpinButton2: TSpinButton;
    procedure NeuesSpiel(Sender: TObject);
    procedure b_neueschiffeClick(Sender: TObject);
    procedure b_v0Change(Sender: TObject);
    procedure ZeichnePlanetenNeu(Sender: TObject);
    procedure ZeichnePlanetNeu(i:integer);
    function naechstgelegenerplanet(x,y:double):integer;
    procedure ZeichneSpielerNeu(i:integer);
    Procedure LoescheSpieler(nr:integer;vx,vy:double);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure b_phi0Exit(Sender: TObject);
    procedure b_phi0Change(Sender: TObject);
    procedure b_v0Exit(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure slprint(n:integer;s:string);
    procedure orbitinfo;
    procedure tim_auswertungTimer(Sender: TObject);
    procedure SpinButton2DownClick(Sender: TObject);
    procedure SpinButton2UpClick(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Panel1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private-Deklarationen }
    procedure ThreadDone(Sender: TObject);
    procedure TruemmerDone(Sender: TObject);
  public
    { Public-Deklarationen }
  end;

var
  F_Universum: TF_Universum;

const gravitation=0.05;

implementation
uses RaumschiffThreads, Titel, Spielernameneingabe, Auswertungsunit;
{$R *.DFM}

function gettempdir:string;
var s:pchar;
begin
  s:='';
  gettemppath(255,s);
  gettempdir:=s;
end;

function hoch(a,b:double):double;
{a hoch b}
begin
  hoch:=exp(b*ln(a));
end;

function strtoreal(s:string):double;
var dummy:integer;
var r:double;
begin
  val(s,r,dummy);
  strtoreal:=r;
end;

function realtostr(r:real):string;
var s:string;
begin
  str(r,s);
  realtostr:=s;
end;


Procedure TF_Universum.ZeichnePlanetNeu(i:integer);
var r:trect;
begin if (i>0) and (i<=anzplaneten) then
with planet[i] do with f_universum do begin
  r.top   :=round(y-radius);
  r.bottom:=round(y+radius);
  r.left  :=round(x-radius);
  r.right :=round(x+radius);
  case bitmapnr of
    0:   canvas.stretchdraw(r,willkommen.erde.picture.bitmap);
    1:   canvas.stretchdraw(r,willkommen.neptun.picture.bitmap);
    2:   canvas.stretchdraw(r,willkommen.jupiter.picture.bitmap);
    3:   canvas.stretchdraw(r,willkommen.jupiter2.picture.bitmap);
    else canvas.stretchdraw(r,willkommen.mond.picture.bitmap);
    end;
end; end;

procedure TF_Universum.slprint(n:integer;s:string);
begin with f_universum do begin
  Statuszeile.panels.items[n].text:=s;
  statuszeile.update;
end; end;

procedure TF_universum.orbitinfo;
var s:string;
begin
  str(anzSchiffeimorbit,s);
  slprint(0,s+' Raketen im Orbit');
end;

var zsv_x1:integer=0;
var zsv_y1:integer=0;
var zsv_x2:integer=0;
var zsv_y2:integer=0;
var zsv_vorhanden:boolean=false;
procedure zeichnestartvektor(x,y:integer;nurloeschen:boolean);
begin with f_universum do begin
  canvas.pen.width:=1;
  canvas.pen.color:=clgreen;
  if zsv_vorhanden then
  begin
    canvas.moveto(zsv_x1,zsv_y1);
    canvas.pen.mode:=pmxor;
    canvas.lineto(zsv_x2,zsv_y2);
    canvas.pen.mode:=pmcopy;
    zsv_vorhanden:=false;
  end;
  if not nurloeschen then
  begin
    zsv_x1:=spieler[aktuellerSpieler].x;
    zsv_y1:=spieler[aktuellerSpieler].y;
    zsv_x2:=x;
    zsv_y2:=y;
    canvas.moveto(zsv_x1,zsv_y1);
    canvas.pen.mode:=pmxor;
    canvas.lineto(zsv_x2,zsv_y2);
    canvas.pen.mode:=pmcopy;
    zsv_vorhanden:=true;
  end;
end; end;


Procedure ZeigeSpielerdaten;
var s:string;
begin with spieler[aktuellerSpieler] do with f_universum do begin
  str(v0:0:3,s);
  b_v0.text:=s;
  str(phi0:0:3,s);
  b_phi0.text:=s;
  l_spielername.caption:=spieler[aktuellerSpieler].name;
  l_spielersymbol.pen.color:=farbe;
end;end;

Procedure TF_Universum.ZeichneSpielerNeu(i:integer);
begin with spieler[i] do
if aktiv then
with f_universum.canvas do begin
  pen.mode:=pmcopy;
  pen.width:=1;

  pen.color:=clblack;
  moveto(round(x-SpielerRadius*cos(alt_phi0*pi/180)),
         round(y+SpielerRadius*sin(alt_phi0*pi/180)));
  lineto(round(x+2*SpielerRadius*cos(alt_phi0*pi/180)),
         round(y-2*SpielerRadius*sin(alt_phi0*pi/180)));
  alt_phi0:=phi0;

  pen.color:=farbe;
  ellipse(x-SpielerRadius,y-SpielerRadius,
          x+SpielerRadius,y+SpielerRadius);

  moveto(round(x-SpielerRadius*cos(phi0*pi/180)),
         round(y+SpielerRadius*sin(phi0*pi/180)));
  lineto(round(x+2*SpielerRadius*cos(phi0*pi/180)),
         round(y-2*SpielerRadius*sin(phi0*pi/180)));
end;end;

Procedure TF_Universum.LoescheSpieler(nr:integer;vx,vy:double);
var dummy:TObject;
begin with spieler[nr] do begin
  aktiv:=false;
  {Explosion des Spielers}
  f_universum.canvas.pen.mode:=pmcopy;
  f_universum.canvas.pen.width:=1;
  f_universum.canvas.pen.color:=clblack;
  {Lschen}
  f_universum.canvas.draw(x-10,y-10,willkommen.blast.picture.bitmap);
  {Explodieren}
   With TTruemmer.create(vx,vy,x,y,spieler[nr].farbe) do
       OnTerminate:=TruemmerDone;
  {Falls der gerade aktive Schtze getroffen wurde,
   drcken wir fr ihn die Start-Taste...}
  if nr=aktuellerspieler then b_neueschiffeClick(dummy);
  dec(aktiveSpielerzahl);
  if aktiveSpielerzahl=1 then
  tim_auswertung.enabled:=true;
end;end;

Procedure TF_Universum.ZeichnePlanetenNeu(Sender: TObject);
var i:integer;
{Schn wre es, herauszufinden, wie gro der Windows-Desktop
 tatschlich ist. 1600x1200 ist zwar die Obergrenze 1997
 gebruchlicher Monitore, aber die Verwendung einer Konstante
 nervt...}
begin
  randseed:=0;
  for i:=1 to 2000 do
    f_Universum.canvas.pixels[random(1600),random(1200)]:=clWhite;
  randomize;
  for i:=1 to anzplaneten do
  ZeichneplanetNeu(i);
  for i:=1 to maxSpielerZahl do
  ZeichneSpielerNeu(i);
end;

procedure TF_Universum.NeuesSpiel(Sender: TObject);
var i,j:integer;
var versuche:integer;
var ok:boolean;
const nichtvorkommendefarbe=clfuchsia;
begin
  auswertung.hide;
  auswertung.close;
  randomize;
  anzplaneten:=2+random(7);
  canvas.brush.color:=clblack;
  canvas.floodfill(1,1,nichtvorkommendefarbe,fsborder);
  for i:=1 to anzplaneten do with planet[i] do
  begin
    versuche:=0;
    repeat
    inc(versuche);
    x:=f_universum.clientwidth*(0.2+0.6*random);
    y:=f_universum.clientheight*(0.2+0.6*random);
    radius:=round(10+random/25*(sqrt(sqr(1.0*clientwidth)+sqr(1.0*clientheight))));
    ok:=true;
    for j:=1 to i-1 do
    if sqrt(sqr(x-planet[j].x)+sqr(y-planet[j].y))<1.5*(radius+planet[j].radius) then ok:=false;
    until ok or (versuche=500);
    masse:=hoch(radius,3)*gravitation;
    bitmapnr:=random(5);
  end;

  {Neue Spieler}
  for i:=1 to maxSpielerzahl do with Spieler[i] do
  if spieler[i].aktiv then
  begin
    versuche:=0;
    repeat
    inc(versuche);
    if random<0.5
    then
      x:=round(f_universum.clientwidth*(0.1+0.2*random))
    else
      x:=round(f_universum.clientwidth*(0.9-0.2*random));
    if random<0.5
    then
      y:=round(f_universum.clientheight*(0.1+0.8*random))
    else
      y:=round(f_universum.clientheight*(0.9-0.2*random));
    ok:=true;
    for j:=1 to anzplaneten do {zu dicht am Planeten?}
    if sqrt(sqr(x-planet[j].x)+sqr(y-planet[j].y))
       <1.5*(spielerradius+planet[j].radius)
    then ok:=false;
    for j:=1 to i-1 do {zu dicht am Mitspieler?}
    if spieler[j].aktiv and
       (sqrt(sqr(x-spieler[j].x)+sqr(y-spieler[j].y))<0.2*clientwidth)
    then ok:=false;
    until ok or (versuche=500);
    aktPunkte:=0;
    getroffenvon:=0;
  end;
  ZeichnePlanetenNeu(Sender);
  f_universum.slprint(1,'Info: martin.vogel@fh-bochum.de');
  ZeigeSpielerDaten;
end;

Procedure tf_universum.ThreadDone(Sender:TObject);
begin
  {Den zuletzt beschdigten Planeten neu zeichnen}
  ZeichnePlanetNeu(destinationplanet);
  destinationplanet:=0;
end;

function TF_Universum.naechstgelegenerplanet(x,y:double):integer;
var i:integer;
var a,mindist:double;
begin
  naechstgelegenerplanet:=1;
  mindist:=1e38;
  for i:=1 to anzplaneten do
  begin
    a:=sqr(planet[i].x-x)+sqr(planet[i].y-y);
    if a<mindist then
    begin
      mindist:=a;
      naechstgelegenerplanet:=i;
    end;
  end;
end;


Procedure tf_universum.TruemmerDone(Sender: TObject);
begin
end;


procedure TF_Universum.b_neueschiffeClick(Sender: TObject);
var as0:integer;
begin with spieler[aktuellerSpieler] do begin
  v0  :=strtoreal(b_v0.text);
  phi0:=strtoreal(b_phi0.text);
  selbstzerstoerung:=false;
  if aktiv then
  {falls er also nicht abgeschossen wurde,
   whrend dieses Formular angezeigt wurde}
  With TRaumschiff.create(v0,
                          x+2*SpielerRadius*cos(phi0*pi/180),
                          y-2*SpielerRadius*sin(phi0*pi/180),
                          phi0,
                          aktuellerSpieler,
                          spieler[aktuellerspieler].farbe) do
       OnTerminate:=ThreadDone;
  {Wer ist der nchste Schtze? Oder ist keiner mehr brig?}
  as0:=aktuellerSpieler;
  repeat
    inc(aktuellerspieler);
    if aktuellerspieler>maxspielerzahl then aktuellerspieler:=1;
  until (as0=aktuellerspieler) or spieler[aktuellerspieler].aktiv;
  ZeichneSpielerNeu(aktuellerspieler);
  ZeigeSpielerdaten;
end; end;

procedure TF_Universum.b_v0Exit(Sender: TObject);
var s:string;
begin with spieler[aktuellerspieler] do begin
  v0:=(strtoreal(b_v0.text));
  if v0<0 then v0:=0;
  if v0>19.99 then v0:=19.99;
  str(v0:0:3,s);
  b_v0.text:=s;
end; end;

procedure TF_Universum.b_v0Change(Sender: TObject);
begin with spieler[aktuellerspieler] do begin
  v0:=(strtoreal(b_v0.text));
  if v0<0 then v0:=0;
  if v0>19.99 then v0:=19.99;
end; end;

procedure TF_Universum.b_phi0Exit(Sender: TObject);
var s:string;
begin  with spieler[aktuellerspieler] do begin
  phi0:=(strtoreal(b_phi0.text));
  while phi0<0 do phi0:=phi0+360;
  while phi0>=360 do phi0:=phi0-360;
  str(phi0:0:3,s);
  b_phi0.text:=s;
end;end;

procedure TF_Universum.b_phi0Change(Sender: TObject);
begin  with spieler[aktuellerspieler] do begin
  phi0:=(strtoreal(b_phi0.text));
  while phi0<0 do phi0:=phi0+360;
  while phi0>=360 do phi0:=phi0-360;
  ZeichneSpielerNeu(aktuellerSpieler);
end;end;

var skp_x0:double=0;
var skp_y0:double=0;
var skp_phi0:double=0;
var skp_v0:double=0;
var skp_vorhanden:boolean=false;
procedure skizzierepfad(v0,phi0:double;nurloeschen:boolean);

  procedure zeichne;
  var x,y,dx,dy,abstand2,abstand3,vx,vy:double;
  var i,j:integer;
  var ende:boolean;
  begin
    with f_universum do
    begin
      x:=skp_x0;
      y:=skp_y0;
      vx:=skp_v0*cos(skp_phi0*pi/180);
      vy:=-skp_v0*sin(skp_phi0*pi/180);
      canvas.pen.mode:=pmxor;
      canvas.pen.color:=clteal;
      canvas.pen.width:=1;
      canvas.moveto(round(x),round(y));
      i:=0;
      repeat
        inc(i);
        ende:=false;
        for j:=1 to anzplaneten do
        begin
          dx:=planet[j].x-x;
          dy:=planet[j].y-y;
          abstand2:=sqr(dx)+sqr(dy);
          abstand3:=abstand2*sqrt(abstand2);
          vx:=vx+dx*planet[j].masse/abstand3;
          vy:=vy+dy*planet[j].masse/abstand3;
          if abstand2<=sqr(planet[j].radius)+9 then ende:=true;
        end;
        x:=x+vx;
        y:=y+vy;
        canvas.lineto(round(x),round(y));
      until (i>=500) or ende;
      skp_vorhanden:=not skp_vorhanden;
    end;
  end;

begin with f_universum do
begin
  if skp_vorhanden then zeichne;
  if not nurloeschen then
  begin
    skp_x0:=spieler[aktuellerspieler].x+2*SpielerRadius*cos(phi0*pi/180);
    skp_y0:=spieler[aktuellerspieler].y-2*SpielerRadius*sin(phi0*pi/180);
    skp_phi0:=phi0;
    skp_v0:=v0;
    zeichne;
  end;
end;
end;

procedure TF_Universum.FormMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var s:string;
var v,phi:double;
var dx,dy:double;
begin
  if ssleft in shift then
  begin
    dx:=spieler[aktuellerspieler].x-x;
    dy:=y-spieler[aktuellerspieler].y;
    if dx=0
    then
      if dy<0
      then phi:=-90
      else phi:=90
    else phi:=180/pi*arctan(dy/dx);
    if dx<0
    then phi:=phi+180
    else
      if dy<0
      then phi:=phi+360;
    str(phi:0:3,s);
    b_phi0.text:=s;
    v:=sqrt(sqr(dx)+sqr(dy))/10;
    if v>10 then v:=10;
    str(v:0:3,s);
    b_v0.text:=s;
    zeichnestartvektor(x,y,false);
    if ssShift in shift then skizzierepfad(v,phi,false);
  end;
end;

procedure TF_Universum.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  zeichnestartvektor(x,y,true);
  skizzierepfad(0,0,true);
  b_neueSchiffeClick(sender);
end;

procedure TF_Universum.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Spielernamen.close;
  Willkommen.close;
  Auswertung.close;
end;

procedure TF_Universum.tim_auswertungTimer(Sender: TObject);
begin
  auswertung.showmodal
end;

procedure TF_Universum.SpinButton2DownClick(Sender: TObject);
var s:string;
begin with spieler[aktuellerspieler] do begin
  v0:=v0-0.1;
  str(v0:0:3,s);
  b_v0.text:=s;
end; end;

procedure TF_Universum.SpinButton2UpClick(Sender: TObject);
var s:string;
begin with spieler[aktuellerspieler] do begin
  v0:=v0+0.1;
  str(v0:0:3,s);
  b_v0.text:=s;
end; end;

procedure TF_Universum.SpinButton1DownClick(Sender: TObject);
var s:string;
begin with spieler[aktuellerspieler] do begin
  phi0:=phi0-1;
  str(phi0:0:3,s);
  b_phi0.text:=s;
end; end;

procedure TF_Universum.SpinButton1UpClick(Sender: TObject);
var s:string;
begin with spieler[aktuellerspieler] do begin
  phi0:=phi0+1;
  str(phi0:0:3,s);
  b_phi0.text:=s;
end; end;


var p1x,p1y:integer;

procedure TF_Universum.Panel1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  if ssleft in shift then
  begin
    panel1.left:=panel1.left+x-p1x;
    panel1.top:=panel1.top+y-p1y;
  end;
end;

procedure TF_Universum.Panel1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  p1x:=x;
  p1y:=y;
end;

end.

